'use strict';
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.waitForNodeJS = exports.loadAWSCredentials = exports.TimeoutError = exports.parseCookies = exports.processJSON = exports.getAbsolutePath = exports.getWinstonConsole = exports.generateRandomHex = exports.get_node_major_version = void 0;
/**
 * Requires
 */
var fs = require("fs");
var path_lib = require("path");
var join = path_lib.join;
var util = require("util");
/**
 * utility functions
 */
function get_node_major_version() {
    return parseInt(process.version.slice(1).split('.')[0]);
}
exports.get_node_major_version = get_node_major_version;
var _hexChars = '0123456789abcdef'.split('');
function generateRandomHex(length) {
    var hexVal = '';
    for (var i = 0; i < length; i++) {
        hexVal += _hexChars[Math.floor(Math.random() * _hexChars.length)];
    }
    return hexVal;
}
exports.generateRandomHex = generateRandomHex;
;
function getWinstonConsole() {
    var winston = require("winston");
    var _a = winston.format, combine = _a.combine, colorize = _a.colorize, simple = _a.simple;
    var logger = winston.createLogger({
        level: "info",
        transports: [
            new winston.transports.Console({
                format: combine(colorize(), simple())
            })
        ]
    });
    return logger;
}
exports.getWinstonConsole = getWinstonConsole;
function getAbsolutePath(path) {
    var homeDir = process.env.HOME || process.env.USERPROFILE;
    var windowsRegex = /([A-Z|a-z]:\\[^*|"<>?\n]*)|(\\\\.*?\\.*)/;
    if (path.match(/^\//) || path.match(windowsRegex)) {
        //On Windows and linux
        return path;
    }
    else {
        if (path === '~') {
            return homeDir;
        }
        else if (path.slice(0, 2) === '~/') {
            return join(homeDir, path.slice(2));
        }
        else if (path.slice(0, 2) === './') {
            return join(process.cwd(), path.slice(2));
        }
        else {
            return join(process.cwd(), path);
        }
    }
    return null;
}
exports.getAbsolutePath = getAbsolutePath;
;
function processJSON(json) {
    if (typeof json === 'object') {
        try {
            return JSON.stringify(json, null, '\t');
        }
        catch (e) {
            return util.inspect(json);
        }
    }
    else {
        return json;
    }
}
exports.processJSON = processJSON;
;
function parseCookies(request) {
    var _a;
    var list = {};
    var cookieHeader = (_a = request.headers) === null || _a === void 0 ? void 0 : _a.cookie;
    if (!cookieHeader)
        return list;
    cookieHeader.split(";").forEach(function (cookie) {
        var _a = cookie.split("="), name = _a[0], rest = _a.slice(1);
        name = name === null || name === void 0 ? void 0 : name.trim();
        if (!name)
            return;
        var value = rest.join("=").trim();
        if (!value)
            return;
        list[name] = decodeURIComponent(value);
    });
    return list;
}
exports.parseCookies = parseCookies;
var TimeoutError = /** @class */ (function (_super) {
    __extends(TimeoutError, _super);
    function TimeoutError(m) {
        var _this = _super.call(this, m) || this;
        _this.name = "TimeoutError";
        return _this;
    }
    return TimeoutError;
}(Error));
exports.TimeoutError = TimeoutError;
var _load_var_from_file = function (varname, envname, data, profileName) {
    if (process.env[envname]) {
        //If already set, it overwrites config files
        return;
    }
    console.log("Loading ".concat(envname, " = ").concat(process.env[envname]));
    var regex = new RegExp('\\[' + profileName +
        '\\](.|\\n|\\r\\n)*?' + varname + '( ?)+=( ?)+(.*)'), match;
    if ((match = regex.exec(data)) !== null) {
        process.env[envname] = match[4];
    }
};
function loadAWSCredentials(path, profileName) {
    if (profileName === void 0) { profileName = 'default'; }
    return __awaiter(this, void 0, void 0, function () {
        var dataRaw, data;
        return __generator(this, function (_a) {
            dataRaw = fs.readFileSync(getAbsolutePath(path)), data = dataRaw.toString();
            _load_var_from_file("aws_secret_access_key", "AWS_SECRET_ACCESS_KEY", data, profileName);
            _load_var_from_file("aws_access_key_id", "AWS_ACCESS_KEY_ID", data, profileName);
            _load_var_from_file("aws_session_token", "AWS_SESSION_TOKEN", data, profileName);
            _load_var_from_file("metadata_service_timeout", "AWS_METADATA_SERVICE_TIMEOUT", data, profileName);
            _load_var_from_file("metadata_service_num_attempts", "AWS_METADATA_SERVICE_NUM_ATTEMPTS", data, profileName);
            _load_var_from_file("region", "AWS_REGION", data, profileName);
            return [2 /*return*/];
        });
    });
}
exports.loadAWSCredentials = loadAWSCredentials;
;
function waitForNodeJS(cb, i) {
    if (i === void 0) { i = 0; }
    /* Waits for all Timeouts to end before calling the callback */
    // This is quite ugly, but its hard to emulate a "wait for all timeouts" properly :/
    if (process.getActiveResourcesInfo().filter(function (x) { return x === 'Timeout'; }).length > i) {
        setTimeout(function () {
            waitForNodeJS(cb, i = 1);
        }, 100);
    }
    else {
        cb();
    }
}
exports.waitForNodeJS = waitForNodeJS;
